package push;
import java.net.URLEncoder;
import java.util.ArrayList;
import java.util.List;

import org.apache.http.HttpEntity;
import org.apache.http.NameValuePair;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.CloseableHttpResponse;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.impl.client.CloseableHttpClient;
import org.apache.http.impl.client.HttpClients;
import org.apache.http.message.BasicNameValuePair;
import org.apache.http.util.EntityUtils;
import org.apache.log4j.Logger;

/**
 * 
 */


public class PushApiTest {

	/**
	 * 
	 */
	public PushApiTest() {
		// TODO Auto-generated constructor stub
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub

		PushApiTest pct = new PushApiTest();

		String cuid = "testuser1";                 // CUID
		String msg = "PUSH발송테스트메시지";       // MESSAGE
		//즉시발송 "", 예약발송 "YYYYMMDD HHMISS"
		String reserveDate = "";                   // RESERVEDATE
		String serviceCode = "ALL";                // SERVICECODE
		String soundFile = "alert.aif";            // SOUNDFILE
		String ext = "";                           // EXT
		String senderCode = "admin";               // SENDERCODE	각 고객사에 맞게 변경 하시기 바랍니다.		
		String appId = "kr.or.m.dev";    					 // APP_ID		각 고객사에 맞게 변경 하시기 바랍니다.
		pct.sendMessage(cuid, msg, reserveDate, serviceCode, soundFile, ext, senderCode, appId);
	}

	public void sendMessage(String cuid, String msg, String reserveDate, String serviceCode, String soundFile, String ext, String senderCode, String appId) {
		
		Logger log = Logger.getLogger(PushApiTest.class);
		
		CloseableHttpClient httpclient = HttpClients.createDefault();
		CloseableHttpResponse response2 = null;
		
		// 해당 URL은 각 고객사에 맞게 변경 하시기 바랍니다.
		HttpPost httpPost = new HttpPost("http://127.0.0.1/rcv_register_message.ctl");
		List <NameValuePair> nvps = new ArrayList <NameValuePair>();
		
		try {
			httpPost.setHeader("Content-Type", "application/x-www-form-urlencoded;charset=UTF-8");
			nvps.add(new BasicNameValuePair("AUTHKEY", ""));
			nvps.add(new BasicNameValuePair("PSID", ""));
			nvps.add(new BasicNameValuePair("CUID", cuid));
			nvps.add(new BasicNameValuePair("MESSAGE", msg));
			nvps.add(new BasicNameValuePair("PRIORITY", "3"));
			nvps.add(new BasicNameValuePair("BADGENO", "1"));
			nvps.add(new BasicNameValuePair("RESERVEDATE", reserveDate));
			nvps.add(new BasicNameValuePair("SERVICECODE", serviceCode));
			nvps.add(new BasicNameValuePair("SOUNDFILE", soundFile));
			nvps.add(new BasicNameValuePair("EXT", ext));
			
			nvps.add(new BasicNameValuePair("SENDERCODE", senderCode));
			nvps.add(new BasicNameValuePair("APP_ID", appId));
			nvps.add(new BasicNameValuePair("TYPE", "E"));
			nvps.add(new BasicNameValuePair("DB_IN", "Y"));
			nvps.add(new BasicNameValuePair("SPLIT_MSG_CNT", "0"));
			nvps.add(new BasicNameValuePair("DELAY_SECOND", "0"));
			nvps.add(new BasicNameValuePair("SEND_TIME_LIMIT", ""));
			
			// DOZ_GCM_SEND
			// GCM도 서비스 가입이 되어 있고 푸시발송서버 UPNS일 경우 일때 
			// UPMC서버설정 또한 GCM_DOZMOD_PROCESS가 ‘Y’로 설정되어 있을 때 해당 파라미터를 ‘Y’로 발송했을 때 
			// GCM으로 dummy data를 날려 Doz모드를 깨어나게 할 때 사용. 
			// Y or N  둘 중 하나 값 사용 
			nvps.add(new BasicNameValuePair("DOZ_GCM_SEND", "Y"));
			
			// PUSH_FAIL_SMS_SEND
			// PUSH5.0 에서만 가능
			// 푸시 발송 실패시 SMS발송처리 여부. 
			// 해당값을 “Y”로 보내면 푸시 발송 실패시SMS 발송테이블(T_PUSH_SMS)에 발송정보가 저장된다.
			nvps.add(new BasicNameValuePair("PUSH_FAIL_SMS_SEND", "N")); 
			// SMS_READ_WAIT_MINUTE
			// PUSH5.0 에서만 가능
			// 0 : 사용 하지 않음. 기타 정수값. (대기 분) 			Ex) 5  
			// 의미: 푸시발송 후 5분안에 수신확인이 들어오지 않은 사용자를 SMS 발송저장테이블((T_PUSH_SMS))에 등록된다. 
			// 주의 : 해당 기능을 사용 할 경우 SMS 문자를 받고 푸시도 중복으로 받을 수 있음을 유의 하시기 바랍니다.
			nvps.add(new BasicNameValuePair("SMS_READ_WAIT_MINUTE", "0"));
			
			httpPost.setEntity(new UrlEncodedFormEntity(nvps, "UTF-8"));
			response2 = httpclient.execute(httpPost);
			
		    System.out.println(response2.getStatusLine());
		    HttpEntity entity2 = response2.getEntity();
		    // do something useful with the response body
		    
		    log.debug("response: " + EntityUtils.toString(entity2));
		    // and ensure it is fully consumed
		    EntityUtils.consume(entity2);
		    
		    
		    
		} catch(Exception e) {
			e.printStackTrace();
		} finally {
			try {
				if(response2 !=null)
					response2.close();
			} catch(Exception ex) {
				
			}
		}
		
	}
	
	
}
